         .MMREGS
         .ds      0f00h
TA       .word    20        ;
RA       .word    20        ;  This set up of AIC registers give
                            ;  a sampling freq of 10,000 Hz
                            ;
TB       .word    25        ;
RB       .word    25        ;
AIC_CTR  .word    08h       ; AIC is in sync mode w/ preamp gain =1
pwidth   .set     040fh     ; a6h for 115200 baud
                            ; 15ah for 57600 baud
                            ; 040fh for 19200 baud
                            ; 081eh for 9600 baud
****************************************************************
*   Set up the ISR vector                                      *
****************************************************************
         .ps      00806h    ; The assembler will not accept branch 
INT3:    B        02000h    ; to labels. Physical addresses used.
         .ps      0080ah    ; Allowing 100 words for the ISR,this
rint:    B        02100h    ; will probably not be enough for the 
xint:    B        02200h    ; INT3 ISR.

         .ps      0980h
         .entry  

       
         SETC    INTM               ;
         LDP     #0                 ;
         OPL     #0834h,PMST        ;
         LACC    #0                 ;
         SAMM    CWSR               ; Clear Wait state control Reg
         SAMM    PDWSR              ; Clear Program/Data wait state Reg
         SPLK    00000h,IOWSR       ; Clear software wait states on I/O
         SETC    SXM                ; SXM MUST BE SET
         SPLK    #026h,IMR          ; This turns on transmit interrupt only
                                    ; Now also int3 on 
         CALL    AICINIT            ; Init AIC
;         SPLK    #006h,IMR          ; Disable RINT and XINT
         CLRC    OVM
         SPM     0                  ;
         CLRC    SXM                ;
         LACC    #0FFFh,4
         CLRC    INTM               ;
         LDP     #pwidth
****************************************************************
*   Circular Buffer Setup at Data address 1000-1020            *
*   20 samples kept.                                           *
*   AR6= start circ buffer AR7 end address circ buffer         *
****************************************************************

         
****************************************************************************
*    Enable circular buffer                                                *
****************************************************************************
         SPLK     #0eh,CBCR          ; Enable circ buf 1  Start addr in AR6
         LACC     #01000h           ; Load ACC with data start address
         SAMM     CBSR1             ; and store in CBSR1
         SAMM     AR6
         ADD      #20               ; Load ACC with data end address
         SAMM     CBER1             ; and store in CBER1 - 20 words long

WAIT:    NOP                        ; wait for a transmit or receive
         B       WAIT
stop:    B       stop
;------- end of main program ----------;

; Codewheel interupt service routine
LOADSLICE:
         .ps     2000h
;         LDP     #0                 ; This is a test instruction to toggle
;         RPT     #100
;         OPL     #00001h,50h        ; the data bit 0 on entering ISR
;         APL     #0fffeh,50h        ;
         SPLK    #006h,IMR          ; This turns off XINT,RINT 
                                    ; Only int3 on. 
         MAR      *,AR6
         SACL     *+,0
         LACC    DRR,0              ; Read DRR register
******* Need to Tx data to PC at this point      **********************
         SPLK    #026h,IMR          ; Enable reloading of AIC data
         RETE
; RECIEVER INTERRUPT SERVICE ROUTINE
;
RCV:
         .ps     02100h
         LDP     #0                 ; This is a test instruction to toggle
;         RPT     #100
         OPL     #00002,50h        ; the data bit 1 on entering ISR
         APL     #0fffdh,50h

         LAMM    DRR                ; Read data from DRR and send it to PC
         RPT     #7                 ; Shift right until LSB of high byte
         SFR                        ; is in the C bit location of ACC
;         CALL xfrbyte               ; Transmit high byte 
;         LACC    DRR
xfrbyte:
         CLRC    C                  ; Clear the  carry bit (C) in accumulator 
         LAR     AR1,#8             ; Load Aux reg with 8
nextbit: BCND    ZERO,NC            ; If C=0 then send a 0 bit
ONE:     SETC    XF                 ; Otherwise send 1 by setting XF pin high
         B       send               ; Send
ZERO:    CLRC    XF                 ; Clear XF ie XF pin low
send:    RPT     #pwidth            ; Repeat for uart bit duration(keep XF=0)
         MAR     *,AR1              ; current AUX reg
         ROR                        ; Rotate acc right to next bit
         BANZ    nextbit,*-         ; Goto next bit if AR is not=0
         SETC    XF                 ; If AR1=0 then send stop bits (XF=1)
         RPT     #pwidth            ; Keep high for stopbit duration
         NOP
         RPT     #pwidth            ; As above
         NOP
         RETE

*
;
; TRANSMIT INTERRUPT SERVICE ROUTINE
;
XMIT:
         .ps    02200h
;        LAMM   DRR
;        AND    #0ffch
;        SAMM   DXR
         RETE

* Not in current use
        .include "initdsk.asm"
        .end
