
	.title	"Digital Sine-Wave Generator"
	.mmregs

;  This routine illustrates the circular addressing capability of
;  TMS320C5x devices. A digital sine wave generator is implemented
;  as a circular buffer #1 with AR7 as its pointer. XSINTBL is the
;  location in external data memory where this table is stored.
;  It is moved to internal data memory block B1 where it is setup
;  as a circular buffer.

XSINTBL .set	02000h

	.text

	LDP	#0
	LAR	AR0,#XSINTBL	;get sine table address in
*				;external memory
	MAR	*,AR0
	LACC	#300h
	SAMM	BMAR		;address of B1 block
*
	RPT	#255		;move 256-word
	BLDD	*+,BMAR 	;table from external to
*				;internal data memory
	SAMM	CBSR1		;start address of buffer=300h
	SAMM	AR7		;AR7 points to start of buffer
	ADD	#255
	SAMM	CBER1		;end address of buffer=3ffh
	SPLK	#0Fh,CBCR	;enable CB#1, disable CB#2
*	 .			;pointer for CB#1 is AR7
*	 .
*	 .
NXTSMP	MAR	*,AR7
	LACC	*+		;get next sample from table
*	 .			;AR7 is updated to next valid sample
*	 .
*	 .
	lacc	*-
DISBLE	APL	#0FFF7h,CBCR	;Disable CB#1
*	 .
*	 .
*	 .
	RET
