* Inserted by .include directive in main progs
******************************************************************
*  DESCRIPTION: This routine initializes the TLC320C40 for       *
*               a 10Khz sample rate with a gain setting of 1     *
*               BP filter cut off at 3.125k and 260Hz            *
******************************************************************
* aic initialization data
*
AICINIT: SPLK    #20h,TCR           ; To generate 10 MHz from Tout
	 SPLK    #01h,PRD           ; for AIC master clock
	 MAR     *,AR0
	 SPLK    #08,SPC            ; Serial port set up
	 SPLK    #0c8h,SPC          ; Enables Tx And Rx ie out of reset
	 LACC    #080h              ; Init 8000h-ffffh as global mem
	 SACH    DXR                ; Dummy word sent to clear SPC reg
	 SACL    GREG               ; Store to global mem alloc reg
	 LAR     AR0,#0FFFFh        ; Use AR0 to pnt to loc FFFFh
	 RPT     #10000             ; Access global mem 10000 cycles
	 LACC    *,0,AR0            ; to drive pin low for duration
	 SACH    GREG               ; Restore GREG to 0000
* Send parameters TA,TB,AIC_CTR to AIC. 10khz sample gain=1 BP enabled         
	 LDP     #TA                ; Init data page
	 SETC    SXM                ; Set sign extension mode
	 LACC    TA,9               ; TA shifted 9 bits
	 ADD     RA,2               ; RA shifted 2 bits
	 CALL    AIC_2ND            ;
	 ;------------------------
	 LDP     #TB                ; Init data page
	 LACC    TB,9               ; Initialize TB and RB register
	 ADD     RB,2               ; As above
	 ADD     #02h               ;
	 CALL    AIC_2ND            ;
	 ;------------------------
	 LDP     #AIC_CTR           ; Init data page
	 LACC    AIC_CTR,2          ; Shift AIC_CTR 2 bits left
	 ADD     #03h               ;
	 CALL    AIC_2ND            ;
	 RET                        ;
*********************************************************************
* This routnine inits a secondary transmission, by the following steps
* 1: Enable serial port transmit interupt
* 2: Send 03h to init transmission
* 3: Wait for new data (idle)
* 4: Send AIC Parameter
* 5: Disable serial port transmit int
*********************************************************************

AIC_2ND:
	 LDP     #0                 ; Data page point is 0  (MM regs)
	 SACH    DXR                ; Send ACChi 00 dummy word
	 CLRC    INTM               ; Enable interrupts
	 IDLE                       ; Wait for TX interrupt
	 ADD     #6h,15             ; 0000 0000 0000 0011 XXXX XXXX XXXX XXXX b
	 SACH    DXR                ; Send ACChi (03) to initiate secondary protocol
	 IDLE                       ; Wait for interrupt
	 SACL    DXR                ; Send the AIC DX data word
	 IDLE                       ; Wait for interrupt
	 LACL    #0                 ; Clear ACClo
	 SACL    DXR                ; Send another to make sure 1st word got sent
	 IDLE                       ; Wait for interrupt
	 SETC    INTM               ; Disable interupts

	 RET                        ;
*

