                                                                                                
            .mmregs                 ;define global symbolic names for
                                    ; TMS320C5x registers.

*******************************************************************************
*                             GLOBAL CONSTANTS                                *
*******************************************************************************

DATA_PORT   .set  0050h             ;memory-mapped data Port Address 0.

*******************************************************************************
*                             GLOBAL VARIABLES                                *
*******************************************************************************

                  .ds         2b80h
BUFFER            .word       0ffffh         
                  .ds         2b81h
BUFFER1           .word       0aaaah
                  .ds         2b82h
BUFFER2           .word       0cccch

*******************************************************************************
*                             INTERRUPT VECTORS                               *
*******************************************************************************

            ;set interrupt vector

            .ps   0803h
            .word 0980h             ;store INT1 ISR address (CLKL signal).
            .ps   0802h
            .word 7980h             ;store branch instruction.
      
*******************************************************************************
*                         INTERRUPT SERVICE ROUTINES                          *
*******************************************************************************

            .ps   0980h             ;assemble code starting at this address.

CLKL_ISR    LAMM  50h
            SACL  BUFFER
            LDP   #0
            OPL   #00001h,DATA_PORT
            APL   #0fffeh,DATA_PORT
            LDP   #87
            IN    BUFFER,DATA_PORT
            LAMM  TIM
            SACL  BUFFER
            RETE

                      ;DON'T FORGET TO UPDATE INTERRUPT VECTORS.

******************************************************************************
*                             SUBROUTINES                                    *
******************************************************************************

            ;TMS320C50 Initialisation.

            ;PMST = Processor Mode STatus register
            ;PRD = timer PeRioD register
            ;TCR = Timer Control Register
            ;IFR = Interrupt Flag Register
            ;IMR = Interupt Mask Register

INITIALISE  LDP   #0                ;data pointer points to page 0.
            SPLK  #0,CWSR           ;configure wait states.
            SPLK  #0,IOWSR          ;zero I/O wait states.
            SPLK  #0,PDWSR          ;zero program/data wait states.
            SPLK  #10h,TCR          ;timer stopped with no prescale.
            SPLK  #19,PRD           ;load timer for 1 us period (20MHz/[19+1]).
            OPL   #01h,IMR          ;unmask INT1 external interrupts.
            SPLK  #0ffffh,IFR       ;clear any pending interrupts.
            CLRC  INTM              ;enable maskable interrupts.
            RET

            ;explanation here

START_CCD   LDP   #0
            SPLK  #20h,TCR          ;reload and start timer.
                                    ;at least 12 cycles to purge pixels.
                                    ; then auto-calibrate.
            RET

*******************************************************************************
*                             MAIN PROGRAM                                    *
*******************************************************************************

            ;explanation of main program

MAIN        CALL  INITIALISE
            CALL  START_CCD
            LDP   #87
            ;LACC  #0                
            NOP
            NOP
BACK        BCND  BACK,UNC    ;,EQ           ;wait for interrupts.
                                    ;branch out when scan finished.
            NOP
            NOP

            .entry MAIN
            .end

;------------------------------------------------------------------------------


