N	.set	4


	.title "NxN Matrix Multiply Routine"
	.mmregs

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This routine performs multiplication of two NxN matrices.
; A x B = C where A,B, and C are NxN in size.
; Entry Conditions:
;	AR1 -> element (0,0) of A (in program space)
;	AR2 -> element (0,0) of B (in data space)
;	AR3 -> element (0,0) of C (in data space)
;	DP  =  0,    NDX = 1
;	ARP =  2
; Storage of matrix elements in memory (beginning from low mem):
;	M(0,0),...,M(0,N-1),M(1,0),...,M(N-1,N-1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ldp	#0
	splk	#3eh,PMST
	splk	#2000h,ar1
	splk	#810h,ar2
	splk	#820h,ar3
	mar	*,ar2

MTRX_MPY:
	LAR	AR0,#(N-1)	;set up loop count
	SPLK	#N,INDX 	;row size
	SAR	AR2,AR4 	;Save addr of B
*				;for i=0,i<N,++i
LOOP1:	SMMR	AR1,BMAR	;BMAR -> A(i,0)
	SPLK	#(N-1),BRCR	;setup loop2 count
	SAR	AR4,AR5 	;AR5 -> B(0,0)
LOOP2:	RPTB	ELOOP2		;for j=0,j<N,++j
	SAR	AR5,AR2 	;AR2 -> B(0,j)
LOOP3:	RPTZ	#(N-1)		;for k=0,k<N,++k
ELOOP3: MADS	*0+		;Acc=A(i,k)xB(k,j)
	APAC			;Final accumulation
	MAR	*,AR5		;ARp = AR5
	MAR	*+,AR3		;AR5 -> B(0,j+1)
ELOOP2: SACL	*+,0,AR2	;Save C(i,j)
	MAR	*,AR0		;loop back if
	BANZD	LOOP1,*-,AR1	;count != N
	ADRK	N		;AR1 -> A(i+1,0)
ELOOP1: MAR	*,AR2		;ARp = AR2
