         .MMREGS
         .ds      0f00h
TA       .word    17        ;
RA       .word    17        ;  This set up of AIC registers give
                            ;  a sampling freq of 10,000 Hz
                            ;
TB       .word    30        ; BP =300-3.6khz
RB       .word    30        ;
AIC_CTR  .word    08h       ; AIC is in sync mode w/ preamp gain =1
pwidth   .set     015ah     ; a6h for 115200 baud
                            ; 15ah for 57600 baud
                            ; 040fh for 19200 baud
                            ; 081eh for 9600 baud
****************************************************************
*   Set up the ISR vector                                      *
****************************************************************
         .ps      00806h    ; The assembler will not accept branch 
INT3:    B        02000h    ; to labels. Physical addresses used.
         .ps      0080ah    ; Allowing 100 words for the ISR,this
rint:    B        02100h    ; will probably not be enough for the 
xint:    B        02200h    ; INT3 ISR.

         .ps      0980h
         .entry  

       
         SETC    INTM               ; Disable interupts
         LDP     #0                 ;
         OPL     #0834h,PMST        ;
         LACC    #0                 ;
         SAMM    CWSR               ; Clear Wait state control Reg
         SAMM    PDWSR              ; Clear Program/Data wait state Reg
         SPLK    00000h,IOWSR       ; Clear software wait states on I/O
         SETC    SXM                ; SXM MUST BE SET
         SPLK    #026h,IMR          ; This turns on transmit interrupt only
                                    ; Now also int3 on 
;         CALL    AICINIT            ; Init AIC
         SPLK    #002h,IMR          ; Disable RINT and XINT and INT3
         CLRC    OVM
         SPM     0                  ;
         CLRC    SXM                ;
         LACC    #0FFFh,4
         CLRC    INTM               ; Enable interupts
;         LDP     #pwidth
****************************************************************
*   Circular Buffer Setup at Data address 1000-1014h           *
*   25 samples kept.                                           *
*   Circular Buffer setup 2 at data address 1020-1052h         *
*   AR6= start circ buffer address slice samples               *
*   AR7= start circ buffer address filtered slice sample       *
****************************************************************

         
****************************************************************************
*    Enable circular buffer                                                *
****************************************************************************
         SPLK     #0feh,CBCR        ; Enable circ buf 1  Start addr in AR6
                                    ; Enable circ buf 2  Start Addr in AR7
         LACC     #01000h           ; Load ACC with data start address
         SAMM     CBSR1             ; and store in CBSR1
         SAMM     AR6
         ADD      #25               ; Load ACC with data end address
         SAMM     CBER1             ; and store in CBER1 - 25 words long
         ADD      #1                ; Add 1 blanks
         SAMM     CBSR2             ; Start of circ buffer 2 #1020h
         SAMM     AR7               ; Store in AR7
         ADD      #50               ; Store 50 slices
         SAMM     CBER2             ; End circ buffer2 #1052h (50 samples)
         ZAP                        ; Clear Accumulator
         

WAIT:    SPLK     #4,IFR            ; Clear INT3 flag
         BIT      IFR,#13           ; wait for a codewheel (int3)
         BCND     LOADSLICE,TC      ; If INT3 then goto loadslice
         B        WAIT              ; Not accepting labels

;------- end of main program ----------;

; Codewheel interupt service routine

         .ps     2000h
LOADSLICE: 
         SPLK    #25,ARCR           ; Load Aux compare with 25        
         ZAP                        ; Accumulator=0
         SAMM    AR1                ; and store in AR1
         
WAITRINT:

         MAR     *,AR1              ; ARP->AR1
         CMPR    0                  ; If ARCR<AR1 20 samples collected
         BCND    RETURN,TC          ; Return to loadslice
         BIT     IFR,#11            ; wait for interupt
         BCND    RCV,TC             ; Get Sample on interupt assertion
         B       WAITRINT           ; Otherwise wait for next RINT
RETURN:         

         LAR     AR1,#25            ; Reset sample count
         SPLK    #4,IFR             ; Clear INT3
         B       WAIT               ; Change to WAIT for contiuous samples

; RECIEVER INTERRUPT SERVICE ROUTINE
;                                                               

         .ps     02100h
RCV:
         MAR     *,AR6             ; ARP-> AR6
         LACC    DRR               ; Read the AIC 
         SACL    *+,0,AR1          ; Store in circular buffer and ARP-> AR1
         MAR     *+,AR6            ; Increment AR1 ARP-> AR6
         SPLK    #010h,IFR         ; Clear RINT
         B       WAITRINT

*
;
; TRANSMIT INTERRUPT SERVICE ROUTINE
;
XMIT:
         .ps    02200h
         RETE

* Not in current use
;        .include "initdsk.asm"
FINISH:
        IDLE
        .end


