*
* Processor initialization for TMS320C50. In case of TMS320C51,
* vector table address should be 800h instead of 2000h (in data
* space).
*
	.ps     00800h
;V_TBL   .sect   "vectors"

RESET   B       INIT            ;This section will be loaded in program
				;memory address 0h.
INT0    B       ISR0            ;INT0- begins processing here
INT1    B       ISR1            ;INT1- begins processing here
INT2    B       ISR2            ;INT2- begins processing here
INT3    B       ISR3            ;INT3- begins processing here
TINT    B       TIME            ;Timer interrupt processing
RINT    B       RCV             ;Serial port receive interrupt
XINT    B       XMT             ;Serial port transmit interrupt
TRNT    B       TRX             ;TDM port receive interrupt
TXNT    B       TXMT            ;TDM port transmit interrupt
INT4    B       ISR4            ;INT4- begins processing here

	.space  14*16           ;14 words

TRAP    B       TRP
NMI     B       NMISR


	.text

INIT    LDP     #0              ;Initialize data pointer
	OPL     #20h,PMST       ;Configure S/A RAM in data memory
	LAR     AR7,#00800h
	MAR     *,AR7
	RPT     #39
	BLPD    #V_TBL,*+       ;Load vector table at 2000h
	SPLK    #0201Eh,PMST    ;Now configure S/A RAM in program space

	SPLK    #01FFh,IMR      ;Clear interrupt mask register
	CLRC    OVM             ;Disable overflow saturation mode

	LAR     AR7,#60h        ;Initialize B2 block
	RPTZ    #31
	SACL    *+

	LAR     AR7,#100h       ;Initialize B0 block
	RPTZ    #511
	SACL    *+

	LAR     AR7,#300h       ;Initialize B1 block
	RPTZ    #511
	SACL    *+

	RETE                    ;Globally enable interrupts
				;and return
