                 .MMREGS
                 .ds      0f00h
pwidth   .set     040fh     ; a6h for 115200 baud
                                     ; 15ah for 57600 baud
                                     ; 040fh for 19200 baud
                                     ; 081eh for 9600 baud
         .ps     0980h
         .entry
         OPL     #0834h,PMST        ;
         LACC    #0                 ;
         SAMM    CWSR               ; Clear Wait state control Reg
         SAMM    PDWSR              ; Clear Program/Data wait state Reg
         SPLK    00000h,IOWSR       ; Clear software wait states on I/O
         SETC    SXM                ; SXM MUST BE SET
         SPLK    #026h,IMR          ; This turns on transmit interrupt only
                                    ; Now also int3 on 
         CLRC    OVM
         SPM     0                  ;
         CLRC    SXM                ;
         LACC    #0FFFh,4
         CLRC    INTM               ;
         LDP     #pwidth
****************************************************************
*   Circular Buffer Setup at Data address 1000-1020            *
*   20 samples kept.                                           *
*   AR6= start circ buffer                                     *
****************************************************************

         
****************************************************************************
*    Enable circular buffer                                                *
****************************************************************************
         SPLK     #0eh,CBCR          ; Enable circ buf 1  Start addr in AR6
         LACC     #01000h           ; Load ACC with data start address
         SAMM     CBSR1             ; and store in CBSR1
         SAMM     AR6
         ADD      #20               ; Load ACC with data end address
         SAMM     CBER1             ; and store in CBER1 - 20 words long
LOADSLICE:
         LDP     #0                 ; This is a test instruction to toggle
         OPL     #00001h,50h        ; the data bit 0 on entering ISR
         APL     #0fffeh,50h        ;
         SPLK    #006h,IMR          ; This turns off XINT,RINT 
                                    ; Only int3 on. 
         MAR      *,AR6
         SACL     *+,0
         LACC    DRR,0              ; Read DRR register
******* Need to Tx data to PC at this point      **********************
         SPLK    #026h,IMR          ; Enable reloading of AIC data
         B       LOADSLICE

         .end
