/* this program will read in a normal text file and write ti out again
   in format expecting from Iain. Ie, each char will be an integerin braille
   format. High byte will contain char, low byte pad will nulls. */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>

#define MAXSTRINGLEN       1024
#define CAPITALINDICATOR   0x4
#define NUMBERINDICATOR    0x3c


int main(int argc, char** argv)

{

FILE           *infile, *outfile;
int            i,j,bufferlen;
unsigned int   outbuffer[MAXSTRINGLEN],inbuffer[MAXSTRINGLEN],temp,temp1;

/* brailleequiv is an array that is used for checking what the braille cell
looks like for that character. */
unsigned int   brailleequiv[128] = {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x5b,0xff,0xff,0xb3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x00,0x74,0x08,0x3c,0xd4,0x94,0xf4,0x20,0xec,0x7c,0x84,0x34,0x04,0x24,0x14,
0x30,0x2c,0x40,0x60,0x48,0x4c,0x44,0x68,0x6c,0x64,0x28,0x8c,0x0c,0xc4,0xfc,
0x38,0x9c,0x12,
/*A*/0x82,0xc2,0x92,0x9a,0x8a,0xd2,0xda,0xca,0x52,0x5a,0xa2,0xe2,0xb2,0xba,
0xaa,0xf2,0xfa,0xea,0x72,0x7a,0xa6,0xe6,0x5e,0xb6,0xbe,0xae,0x56,0xce,0xde,
0x1a,0x1e,0x10,
/*a*/0x80,0xc0,0x90,0x98,0x88,0xd0,0xd8,0xc8,0x50,0x58,0xa0,0xe0,0xb0,0xb8,
0xa8,0xf0,0xf8,0xe8,0x70,0x78,0xa4,0xe4,0x5c,0xb4,0xbc,0xac,0x54,0xcc,0xdc,
0x18,0x1c};




if (argc < 3)
   {
      printf("Usage txttobrl infile outfile\n");
      exit(1);
   }

if ((infile = fopen(argv[1],"r")) == NULL)
   {
      printf("Could not open text file\n");
      exit(1);
   }
else
    printf("%s opened successfully\n",argv[1]);

if ((outfile = fopen(argv[2],"wb")) == NULL)
   {
      printf("Could not open text file\n");
      exit(1);
   }
else
    printf("%s opened successfully\n",argv[2]);

i = 0;    /* read in file into inbuffer */
while (!feof(infile))
   {
      inbuffer[i] = fgetc(infile);
      i++;
   }
bufferlen = i;     /* find out how long string in buffer is */
i = 0;
j = 0;
while (i <= bufferlen)
   {
      temp = inbuffer[i];
      if ((temp >= 0x41) && (temp <=0x5a))
         {
            temp1 = CAPITALINDICATOR;
            temp1 *= 256;    /* Move char up to high byte */
            outbuffer[j] = temp1;
            j++;
         }
      else
         {
         if ((temp >= 0x30) && (temp <=0x39))
            {
               outbuffer[j] = NUMBERINDICATOR;
               outbuffer[j] *= 256;    /* Move char up to high byte */
               j++;
            }
         }
      outbuffer[j] = brailleequiv[temp];
      outbuffer[j] *= 256;    /* Move char up to high byte */
      i++;
      j++;
   }

bufferlen = j;

for (i = 0; i <= bufferlen; i++)
    fprintf(outfile,"%04x ",outbuffer[i]);


fclose(infile);
fclose(outfile);
return(0);
}/* end main */