

	.title	"Routine to extract bits from a single word"

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*	PCKD
*	----------------
*	|Bn  ------  B0|
*	----------------
*
*	UNPCKD
*	----------------
*	|0   --   0 |Bn|
*	----------------
*	|0   --  0|Bn-1|
*	----------------
*	      . .
*	----------------
*	|0   --    0|B0|
*	----------------
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.mmregs

NO_BITS .set	16		;number of packed bits in the word

PCKD	.set	60h		;Input word
UNPCKD	.set	61h		;Output buffer. Each word will have
				;one bit in LSB location.

	.text

UNPACK	LDP	#0		;DP=0
	MAR	*,AR0
	LAR	AR0,#UNPCKD+NO_BITS-1 ;End of table address
	SPLK	#NO_BITS-1,BRCR ;Initialize the count register
	SPLK	#1,DBMR 	;Load mask in DBMR register
	LACC	PCKD		;Packed bits -> Acc

	RPTB	LOOP-1		;Begin looping
	SACL	*		;Save remaining packed bits
	APL	*-		;Keep the LSB only
	SFR			;Shift right to throw away unpacked bit

LOOP	RET			;Return back
