	.title	"Convolutional Encoding for a V.32 Modem"


	.mmregs
	.length 55
	.width 120


STATMEM 	.set	60h	;(60h - 62h) Delay States S1,S2,S3
OUTPUT		.set	63h	;Y0, the redundant bit
INPUT		.set	64h	;(64h - 67h) Four input bits
YPAST		.set	68h	;(68h - 69h) Past values of Y1 and Y2
LOCATE		.set	6ah	;Temporary storage for current input word
PCKD_IP 	.set	1000h	;Input buffer (4 bits packed per word)
PCKD_OP 	.set	3000h	;Output buffer (5 bits packed per word)
COUNT		.set	48	;# of input data words



		.text

INIT	LAR	AR1,#PCKD_IP
	LAR	AR2,#PCKD_OP
	LAR	AR3,#COUNT-1	;COUNT contains # of input words
	LDP	#0
*
	LAR	AR0,#STATMEM
	MAR	*,AR0
	LACL	#0
	RPT	#20h
	SACL	*+
*
START	MAR	*,AR1
	LACC	*+,0,AR0
	SACL	LOCATE		;Temporary storage for current input word

	LAR	AR0,#INPUT+3
	LACL	#3
	SAMM	BRCR
	LACL	#1
	SAMM	DBMR

UNPACK	LACC	LOCATE		;Acc = packed input bits
	RPTB	LOOP1-1
	SACL	*		;Save it
	APL	*-
	SFR			;Shift right to get next bit
LOOP1
	CALL	DIFF
	CALL	ENCODE

PACK	LAR	AR0,#OUTPUT
	MAR	*,AR0
	LACL	#3		;Loop 4 times only
	SAMM	BRCR
	LACC	*+		;Get first bit (MSB)

	RPTB	LOOP2-1
	SFL
	ADD	*+		;Pack next bit by left-shifting other
	NOP
LOOP2
	MAR	*,AR2
	SACL	*+,0,AR3	;Save it in packed form
*
	BANZ	START		;Loop if COUNT is not zero
	RET

*********************************************************************

DIFF	LACC	YPAST
	AND	INPUT		;Q1n & Y1n-1
	XOR	INPUT+1 	;(Q1n & Y1n-1) xor Q2n
	XOR	YPAST+1 	;(Q1n & Y1n-1) xor Q2n xor Y2n-1
	SACL	INPUT+1
	SACL	YPAST+1 	;Save Y2n
	LACC	YPAST
	XOR	INPUT		;Q1n xor Y1n-1
	RETD
	SACL	INPUT
	SACL	YPAST


********************************************************************

ENCODE	LACC	STATMEM
	SACL	OUTPUT		;Y0 <- S1
	LACC	INPUT+1
	XOR	STATMEM+1	;Y2 xor S2
	SACB
	LACC	OUTPUT
	AND	INPUT		;Y0 & Y1
	XORB			;(Y0 & Y1) xor (Y2 xor S2)
	SACL	STATMEM 	;Save it in S1
	LACC	OUTPUT
	ANDB			;Y0 & (Y2 xor S2)
	SACB
	LACC	INPUT
	XOR	INPUT+1 	;Y1 xor Y2
	XOR	STATMEM+2	;(Y1 xor Y2) xor S3
	XORB			;((Y1 xor Y2) xor S3) xor (Y0 & (Y2 xor S2))
	SACL	STATMEM+1	;Update S2
	RETD
	LACC	OUTPUT
	SACL	STATMEM+2	;Update S3
